//   see default.fx effect for useful comments
//
//










float3 lightposn={0.4,0.4,0.8};  // in world space
float3 diffuse = {0.6,0.6,0.6};
float3 ambient={0.5,0.5,0.5};


float4x4 WorldViewProj ;
float4x4 World ;
texture diffusemap : DiffuseMap;

sampler samp = sampler_state
{
	texture = <diffusemap>;
	AddressU = WRAP;
	AddressV = WRAP;
	MIPFILTER = LINEAR;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

struct VS_INPUT
{
	float4 position : POSITION;
	float4 normal   : NORMAL;
	float4 texcoord : TEXCOORD;
};

struct VtoP
{
	float4 position : POSITION;
	float4 tex      : TEXCOORD;
	float4 color    : COLOR;
};

VtoP vertex_shader(const VS_INPUT IN)
{
	VtoP OUT;
	float4 p = mul(IN.position, WorldViewProj);
	OUT.position = p;
	float4 pw = mul(IN.position, World);
	float3 lightdir = normalize(lightposn - pw.xyz);
	float dp = dot(IN.normal.xyz,lightdir);
	dp = clamp(dp,0,1);
	OUT.color.xyz =  ambient + diffuse*dp;
	OUT.color.w = 1.0;
	OUT.tex = IN.texcoord;

	return OUT;
}

struct PS_OUTPUT
{
	float4 color : COLOR0;
};

PS_OUTPUT pixel_shader(const VtoP IN)
{
	PS_OUTPUT OUT;
	OUT.color = IN.color * tex2D(samp, IN.tex);
	return OUT;
}

technique t0
{
	pass p0
	{
		//DEPTHBIAS = 0;
		TWOSIDEDSTENCILMODE = FALSE;
		ZENABLE = TRUE;
		ZFUNC = LESSEQUAL ;
		ZWRITEENABLE =     TRUE ;
		CullMode = NONE;
		STENCILENABLE=    FALSE  ;
		ALPHABLENDENABLE= FALSE ;
		SHADEMODE = GOURAUD ;
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}
}

