


float4x4 World ;
float4x4 ViewProj ;
float3 lightcolor={0.2,1.0,0.2};
float3 lightposn={0.0f , 0.0f, 2.0f };
float  lightradius = 20.0f;
int useskin=0;
static const int MAX_MATRICES = 26;
float4x4    WorldMatrixArray[MAX_MATRICES] : WORLDMATRIXARRAY;

struct VS_INPUT
{
	float4 position : POSITION;
	float4 normal   : NORMAL;
};

struct VertexS 
{
    float4 position : POSITION;
    float4 weights  : BLENDWEIGHT;
    int4   bones    : BLENDINDICES;
    // float4 color	: COLOR0;
    float3 normal	: NORMAL;
    float2 texcoord	: TEXCOORD0;
    float3 tangent	: TANGENT0;
    float3 binormal	: BINORMAL0;
};



float4 vertex_shader_skin(VertexS IN):POSITION
{
	int4 bones = IN.bones; // unlike skinnedmesh.fx from d3d sample, they used float instead of int.

	// vertex position in world space
	float4 position = float4(0,0,0,0);
	position += mul(IN.position,WorldMatrixArray[bones.x]) * IN.weights.x;
	position += mul(IN.position,WorldMatrixArray[bones.y]) * IN.weights.y;
	position += mul(IN.position,WorldMatrixArray[bones.z]) * IN.weights.z;
	position += mul(IN.position,WorldMatrixArray[bones.w]) * IN.weights.w;

	float3 normal=float3(0,0,0);
	normal += mul(IN.normal,WorldMatrixArray[bones.x]) * IN.weights.x;
	normal += mul(IN.normal,WorldMatrixArray[bones.y]) * IN.weights.y;
	normal += mul(IN.normal,WorldMatrixArray[bones.z]) * IN.weights.z;
	normal += mul(IN.normal,WorldMatrixArray[bones.w]) * IN.weights.w;

	float4 p = position;
	float3 fudge= 0; // = normalize(IN.position.xyz) * -0.001; // moves point slightly toward local origin - helps in some cases when light is coplanar with poly using a uniform shadow (big gray stenciled poly) 
	float4 n;
	//  n  =  mul(IN.normal,   World);
	n.xyz = normal;
	n.w=0;
	//p.xyz = p.xyz + (n.xyz*0.5);
	float3 l = normalize(lightposn-p.xyz);
	float d = dot(l,n.xyz);
	float extend;
	if(d<0) 
	{
		extend = lightradius*5;
	}
	else
	{
		extend = 0.01;
	}
	p.xyz = p.xyz + (l.xyz * -extend) +fudge;// + (n.xyz*0.01);

/*	if(p.x < lightposn.x-lightradius  && l.x > 0.01 && d<0 )
	{
		p.xyz += l * ( (lightposn.x-lightradius-p.x) /l.x);
	}
	if(p.y < lightposn.y-lightradius && l.y > 0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.y-lightradius-p.y) /l.y);
	}
	if(p.z < lightposn.z-lightradius && l.z > 0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.z-lightradius-p.z) /l.z);
	}

	if(p.x > lightposn.x+lightradius  && l.x < -0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.x+lightradius-p.x) /l.x);
	}
	if(p.y > lightposn.y+lightradius && l.y < -0.01 && d<0)
	{
		p.xyz += l * ( (lightposn.y+lightradius-p.y) /l.y);
	}
	if(p.z > lightposn.z+lightradius && l.z < -0.01 && d<0)
	{
		p.xyz += l * ( (lightposn.z+lightradius-p.z) /l.z);
	}
*/
	return mul(p,ViewProj);
}


float4 vertex_shader(float4 position : POSITION,float4 normal   : NORMAL):POSITION
{
	float4 p = mul(position, World);
	float3 fudge= 0; // = normalize(IN.position.xyz) * -0.001; // moves point slightly toward local origin - helps in some cases when light is coplanar with poly using a uniform shadow (big gray stenciled poly) 
	float4 n = normal;
	//  n  =  mul(IN.normal,   World);
	n.xyz = World[0].xyz * normal.x +  World[1].xyz * normal.y +  World[2].xyz * normal.z ;
	n.w=0;
	//p.xyz = p.xyz + (n.xyz*0.5);
	float3 l = normalize(lightposn-p.xyz);
	float d = dot(l,n.xyz);
	float extend;
	if(d<0) 
	{
		extend = lightradius*5;
	}
	else
	{
		extend = 0.01;
	}
	p.xyz = p.xyz + (l.xyz * -extend) +fudge;// + (n.xyz*0.01);

/*	if(p.x < lightposn.x-lightradius  && l.x > 0.01 && d<0 )
	{
		p.xyz += l * ( (lightposn.x-lightradius-p.x) /l.x);
	}
	if(p.y < lightposn.y-lightradius && l.y > 0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.y-lightradius-p.y) /l.y);
	}
	if(p.z < lightposn.z-lightradius && l.z > 0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.z-lightradius-p.z) /l.z);
	}

	if(p.x > lightposn.x+lightradius  && l.x < -0.01  && d<0)
	{
		p.xyz += l * ( (lightposn.x+lightradius-p.x) /l.x);
	}
	if(p.y > lightposn.y+lightradius && l.y < -0.01 && d<0)
	{
		p.xyz += l * ( (lightposn.y+lightradius-p.y) /l.y);
	}
	if(p.z > lightposn.z+lightradius && l.z < -0.01 && d<0)
	{
		p.xyz += l * ( (lightposn.z+lightradius-p.z) /l.z);
	}
*/
	return mul(p,ViewProj);
}


float4 pixel_shader():COLOR0
{
	float4 color;
	color.xyz = lightcolor ;
	color.w=1.0;
	return color;
}

VertexShader vsArray[2] = { compile vs_2_0 vertex_shader(), 
                            compile vs_2_0 vertex_shader_skin(),
};


technique t0
{
//	pass p0
//	{
//		ZENABLE = TRUE;
//		CullMode = NONE;
//		FILLMODE=WIREFRAME;
//		ZWRITEENABLE= FALSE ;
//		PixelShader  = compile ps_2_0 pixel_shader();
//		VertexShader = compile vs_2_0 vertex_shader();
//	}
	pass p1
	{
		ZENABLE = TRUE;
		ZFunc = GREATER;
		CullMode = NONE;
		FILLMODE=SOLID;
		ZWRITEENABLE= FALSE ;
		STENCILENABLE=TRUE ;

		// Dont bother with interpolating color
		SHADEMODE=   FLAT ;
		DEPTHBIAS = 0;
		SLOPESCALEDEPTHBIAS	= 0;	
		// Set up stencil compare fuction, reference value, and masks.
		// Stencil test passes if ((ref & mask) cmpfn (stencil & mask)) is true.
		// Note: since we set up the stencil-test to always pass, the STENCILFAIL
		// renderstate is really not needed.
		STENCILFUNC= ALWAYS ;
		STENCILZFAIL=KEEP ;
		STENCILFAIL= KEEP ;

		// If ztest passes, inc/decrement stencil buffer value
		STENCILREF=      0x1 ;
		STENCILMASK=     0xffffffff ;
		STENCILWRITEMASK=0xffffffff ;
		STENCILPASS=     INCR ;

		// Make sure that no pixels get drawn to the frame buffer
		ALPHABLENDENABLE=TRUE ;
		SRCBLEND= ZERO ;
		DESTBLEND=ONE ;


        TWOSIDEDSTENCILMODE= TRUE ;
        CCW_STENCILFUNC=  ALWAYS ;
        CCW_STENCILZFAIL= KEEP ;
        CCW_STENCILFAIL=  KEEP ;
        CCW_STENCILPASS=  DECR;

    
 
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = vsArray[useskin]; // compile vs_2_0 vertex_shader();
	}
}


technique t2pass
{
	pass p0
	{
		CullMode = NONE;
		FILLMODE=WIREFRAME;
		DEPTHBIAS = 0;
		TWOSIDEDSTENCILMODE = FALSE;
		STENCILENABLE=    FALSE  ;
		ALPHABLENDENABLE= FALSE ;
		SHADEMODE = GOURAUD ;
		ZWRITEENABLE =     TRUE ;
		ZENABLE = TRUE;
		ZFUNC = LESSEQUAL ;
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}
	pass p1
	{
		ZENABLE = TRUE;
		CullMode = CW;
		FILLMODE=SOLID;

		ZWRITEENABLE= FALSE ;
		STENCILENABLE=TRUE ;

		// Dont bother with interpolating color
		SHADEMODE=   FLAT ;

		// Set up stencil compare fuction, reference value, and masks.
		// Stencil test passes if ((ref & mask) cmpfn (stencil & mask)) is true.
		// Note: since we set up the stencil-test to always pass, the STENCILFAIL
		// renderstate is really not needed.
		STENCILFUNC= ALWAYS ;
		STENCILZFAIL=KEEP ;
		STENCILFAIL= KEEP ;

		// If ztest passes, inc/decrement stencil buffer value
		STENCILREF=      0x1 ;
		STENCILMASK=     0xffffffff ;
		STENCILWRITEMASK=0xffffffff ;
		STENCILPASS=     INCR ;

		// Make sure that no pixels get drawn to the frame buffer
		ALPHABLENDENABLE=TRUE ;
		SRCBLEND= ZERO ;
		DESTBLEND=ONE ;

		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}	
	pass p2
	{
		ZENABLE = TRUE;
		CullMode = CCW;
		FILLMODE=SOLID;

		ZWRITEENABLE= FALSE ;
		STENCILENABLE=TRUE ;

		// Dont bother with interpolating color
		SHADEMODE=   FLAT ;

		// Set up stencil compare fuction, reference value, and masks.
		// Stencil test passes if ((ref & mask) cmpfn (stencil & mask)) is true.
		// Note: since we set up the stencil-test to always pass, the STENCILFAIL
		// renderstate is really not needed.
		STENCILFUNC= ALWAYS ;
		STENCILZFAIL=KEEP ;
		STENCILFAIL= KEEP ;

		// If ztest passes, inc/decrement stencil buffer value
		STENCILREF=      0x1 ;
		STENCILMASK=     0xffffffff ;
		STENCILWRITEMASK=0xffffffff ;
		STENCILPASS=     DECR ;

		// Make sure that no pixels get drawn to the frame buffer
		ALPHABLENDENABLE=TRUE ;
		SRCBLEND= ZERO ;
		DESTBLEND=ONE ;

 
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}
}


technique debug
{
	pass p0
	{
		ZENABLE = TRUE;
		CullMode = NONE;
		FILLMODE=WIREFRAME;
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = vsArray[useskin]; // compile vs_2_0 vertex_shader();
	}
}
