// 
// Simple Screen Space fx for huds
//
//
//---------------------------------------------------------


float4x4 Proj;
//float oneoverwidth=1.0f/640.0f; 
//float oneoverheight=1.0f/480.0f;

texture diffusemap : DiffuseMap;

sampler samp = sampler_state
{
	texture = <diffusemap>;
	AddressU = WRAP;
	AddressV = WRAP;
	MIPFILTER = LINEAR;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

struct VS_INPUT
{
	float4 position : POSITION;
	float4 texcoord : TEXCOORD;
};

struct VtoP
{
	float4 position : POSITION;
	float2 texcoord : TEXCOORD;
	//float4 color    : COLOR;
};


VtoP vertex_shader( VS_INPUT In )
{
	VtoP Out;
	//Out.position = mul(In.position, Proj); 
	//Out.position = float4(sign(In.position.xy),1.0,1.0);
	Out.position = In.position; //float4(sign(In.position.xy),1.0,1.0);
	Out.texcoord.x = In.texcoord.x;
	Out.texcoord.y = 1.0-In.texcoord.y;  // prefer opengl origin in bottom left and right handed conventions
	return Out;
}


float4 pixel_shader(float2 uv : TexCoord0): Color0 
{
	// derive world space position based on center of projection, depth at pixel, and viewing direction at this pixel in world space
	return tex2D(samp,uv);
}

technique t0
{
	pass p0
	{
		DEPTHBIAS = 0;
		STENCILENABLE=    FALSE  ;
		TWOSIDEDSTENCILMODE = FALSE;
		CCW_STENCILPASS=KEEP;
		STENCILPASS=     KEEP;
		STENCILFAIL=     KEEP;
		STENCILZFAIL=     KEEP;
		ZWRITEENABLE=     FALSE ;
		ZENABLE = FALSE;
		ZFUNC = LESSEQUAL ;
		STENCILREF=  0x01 ;
		STENCILFUNC= GREATER; // since unlike shadowpoly we want to draw where shadow isn't  // LESSEQUAL ;
		FOGENABLE=        FALSE ;
		ALPHABLENDENABLE= FALSE  ;
		SHADEMODE = GOURAUD ;
		SRCBLEND=  ONE ;
		DESTBLEND= ONE ;
		CullMode = NONE;
		FILLMODE=SOLID;
		// VertexShader = null;
		VertexShader = compile vs_2_0 vertex_shader();
		PixelShader = compile ps_2_0 pixel_shader();
	}
}
