//   
// marker effect, typicall used for drawing lines and crap just to mark stuff 
// we assume input verticies are already in world coord space!!
//

float4x4 ViewProj ;

struct VertexPC
{
	float4 position : POSITION;
	float4 color    : COLOR;
	float2 texcoord : TEXCOORD;
};

struct VtoPpc
{
	float4 position : POSITION;
	float4 color    : COLOR;
};

VtoPpc vertex_shader_position_color(const VertexPC IN)  // assumes vertex is already in world space, passes color through
{
	VtoPpc OUT;
	float4 p = mul(IN.position, ViewProj);
	OUT.position = p;
	OUT.color    = IN.color;
	return OUT;
}


float4 pixel_shader_color(const VtoPpc IN):COLOR0
{
	return IN.color;
}

technique marker
{
	pass p0
	{
		STENCILENABLE=    FALSE  ;
		ALPHABLENDENABLE= FALSE ;
		SHADEMODE = GOURAUD ;
		ZWRITEENABLE =     TRUE ;
		ZENABLE = TRUE;
		CullMode = CW;
		PixelShader  = compile ps_2_0 pixel_shader_color();
		VertexShader = compile vs_2_0 vertex_shader_position_color();
	}
}

