
//
//  quick reflection effect
//


float4x4 WorldViewProj ;
float4x4 World ;
float4x4 View ;
float4x4 ViewInv ;
textureCUBE envmap;

samplerCUBE samp = sampler_state
{
	texture = <envmap>;
	AddressU = CLAMP;
	AddressV = CLAMP;
	AddressW = CLAMP;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

struct VS_INPUT
{
	float4 position : POSITION;
	float4 normal   : NORMAL;
};

struct VtoP
{
	float4 position : POSITION;
	float4 envtex   : TEXCOORD1;
	float3 c:TEXCOORD2;
	float3 n:TEXCOORD3;
};

VtoP vertex_shader(const VS_INPUT IN)
{
	VtoP OUT;
	OUT.position =  mul(IN.position, WorldViewProj);
	float4 p =mul(IN.position, World);

	float3 n;
	//  n  =  mul(IN.normal,   World);
	n.xyz = World[0].xyz * IN.normal.x +  World[1].xyz * IN.normal.y +  World[2].xyz * IN.normal.z ;

	float3 cp = ViewInv[3].xyz - p.xyz;
	float4 t;
	t.w=0;
	t.xyz =  -cp + n*(2*dot(n,cp));
	OUT.c = cp;
	OUT.n = n;
	OUT.envtex = t * -1;  // HACK - something was strange in the dynamic cube map generation, unless i reverse the winding (culling), note i've been consistenly right-handed
	return OUT;
}

struct PS_OUTPUT
{
	float4 color : COLOR0;
};

PS_OUTPUT pixel_shader(const VtoP IN)
{
	PS_OUTPUT OUT;
	OUT.color = texCUBE(samp, IN.envtex);
	return OUT;
}
PS_OUTPUT pixel_shader2(const VtoP IN)
{
	PS_OUTPUT OUT;
	OUT.color = texCUBE(samp, reflect(IN.c,normalize(IN.n))); 
	return OUT;
}

technique t0
{
	pass p0
	{
		TWOSIDEDSTENCILMODE = FALSE;
		ZENABLE = TRUE;
		CullMode = CW;
		STENCILENABLE=    FALSE  ;
		ALPHABLENDENABLE= FALSE ;
		SHADEMODE = GOURAUD ;
		ZWRITEENABLE =     TRUE ;
		PixelShader  = compile ps_2_0 pixel_shader2();
		VertexShader = compile vs_2_0 vertex_shader();
	}
}


technique t1
{
	pass p0
	{
		TWOSIDEDSTENCILMODE = FALSE;
		ZENABLE = TRUE;
		CullMode = CW;
		STENCILENABLE=    FALSE  ;
		ALPHABLENDENABLE= FALSE ;
		SHADEMODE = GOURAUD ;
		ZWRITEENABLE =     TRUE ;
		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}
}

