


float4x4 Proj ;
float4 shadowcolor={0.0, 0.0, 0.0, 0.5};

struct VS_INPUT
{
	float4 position : POSITION;
};

struct VtoP
{
	float4 position : POSITION;
	float4 color    : COLOR;
};

VtoP vertex_shader(const VS_INPUT IN)
{
	VtoP OUT;
	float4 p = mul(IN.position, Proj);
	OUT.position = p;
	OUT.color = shadowcolor;
	return OUT;
}

struct PS_OUTPUT
{
	float4 color : COLOR0;
};

PS_OUTPUT pixel_shader(const VtoP IN)
{
	PS_OUTPUT OUT;
	OUT.color = IN.color ;
	return OUT;
}

technique t0
{
	pass p0
	{
		DEPTHBIAS = 0;
		STENCILENABLE=    TRUE  ;
		TWOSIDEDSTENCILMODE = FALSE;
		CCW_STENCILPASS=KEEP;
		STENCILPASS=     KEEP;
		STENCILFAIL=     KEEP;
		STENCILZFAIL=     KEEP;
		ZENABLE=          FALSE ;
		ZWRITEENABLE=     FALSE ;
		STENCILREF=  0x01 ;
		STENCILFUNC= LESSEQUAL ;
		FOGENABLE=        FALSE ;
		ALPHABLENDENABLE= TRUE  ;
		SRCBLEND=  SRCALPHA ;
		DESTBLEND= INVSRCALPHA ;

		CullMode = NONE;
		FILLMODE=SOLID;
		ZFunc = LESSEQUAL ;

		PixelShader  = compile ps_2_0 pixel_shader();
		VertexShader = compile vs_2_0 vertex_shader();
	}
}

